<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Src/NLME/Auxiliary/callSimulation.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_413f4e031a85da0d68269c6fd2f76e1c.html">Src</a></li><li class="navelem"><a class="el" href="../../dir_8672bca13fc16af0e54d5ddc01090308.html">NLME</a></li><li class="navelem"><a class="el" href="../../dir_d544197a650feee977d1b0e201b59710.html">Auxiliary</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">callSimulation.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d3/d84/_src_2_n_l_m_e_2_auxiliary_2call_simulation_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">function</span> [time_points,observed_y,unobserved_states,observed_sens_y,Hessian,FIM,measurement_sd,residuals] = <a class="code" href="../../d7/df5/_projects_2_llamosi2016_2_user_fns_2call_simulation_8m.html#a675cf3332f7c9140d55c01870b188396">callSimulation</a>(time_exp,kinetic_param,ydata_response,theta_hat,int_opts,type)</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;fn_handle=int_opts.model;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;tsp0=time_exp;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keywordflow">if</span>(isfield(int_opts,<span class="stringliteral">&#39;t0&#39;</span>))</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    t0=int_opts.t0;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keywordflow">else</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    t0=tsp0(1);</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;end</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;% If Hessian and FIM need to be returned</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keywordflow">if</span> ~isempty(ydata_response)</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    options = amioption(<span class="stringliteral">&#39;sensi&#39;</span>,2,<span class="stringliteral">&#39;sensi_meth&#39;</span>,<span class="stringliteral">&#39;forward&#39;</span>,...</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="stringliteral">&#39;atol&#39;</span>,int_opts.abstol,<span class="stringliteral">&#39;rtol&#39;</span>,int_opts.rtol,<span class="stringliteral">&#39;ism&#39;</span>,1,<span class="stringliteral">&#39;tstart&#39;</span>,t0);</div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="../../d3/d84/_src_2_n_l_m_e_2_auxiliary_2call_simulation_8m.html#a99a7658730331dcf394913c42a179f53">   17</a></span>&#160;    n_obs=(unique(ydata_response.YID));</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    simdat.Y=[];</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keywordflow">for</span>( i=1:length(n_obs))</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        simdat.Y=cat(2,simdat.Y,ydata_response.Y(ydata_response.YID==n_obs(i))); % TODO: make a separate <span class="keyword">function</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    end</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    simdat.Sigma_Y=<a class="code" href="../../d8/d7b/var_fun_8m.html#ae8689ef39372b131ddb25d7da78d2b87">varFun</a>(theta_hat,simdat.Y,type);</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    % <span class="keywordflow">if</span> second order sensitivities were not computed, <span class="keywordflow">catch</span> the error and</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    % use only first order.</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    MExc=[];</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordflow">try</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    sol0=fn_handle(tsp0,kinetic_param,int_opts.k,simdat,options);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordflow">catch</span> MExc</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        disp(MExc);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;       disp(<span class="stringliteral">&#39;Using only first-order sensitivities and getting FIM&#39;</span>);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;       options = amioption(<span class="stringliteral">&#39;sensi&#39;</span>,1,<span class="stringliteral">&#39;sensi_meth&#39;</span>,<span class="stringliteral">&#39;forward&#39;</span>,...</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="stringliteral">&#39;atol&#39;</span>,int_opts.abstol,<span class="stringliteral">&#39;rtol&#39;</span>,int_opts.rtol,<span class="stringliteral">&#39;ism&#39;</span>,1,<span class="stringliteral">&#39;tstart&#39;</span>,t0);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    sol0=fn_handle(tsp0,kinetic_param,int_opts.k,simdat,options);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    end</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    % aggregate results.</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    time_points=cat(1,sol0.t);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    observed_y=cat(1,sol0.y);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    unobserved_states=cat(1,sol0.x);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    % sensitivities</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    observed_sens_y=sol0.sy;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    Hessian=-sol0.s2llh;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    FIM=sol0.sllh*sol0.sllh<span class="stringliteral">&#39;;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="stringliteral">    measurement_sd=simdat.Sigma_Y;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="stringliteral">    residuals=simdat.Y-sol0.y;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="stringliteral">else</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="stringliteral">    MExc=[];</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="stringliteral">    try</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="stringliteral">    options = amioption(&#39;</span>sensi<span class="stringliteral">&#39;,1,&#39;</span>sensi_meth<span class="charliteral">&#39;,&#39;</span>forward<span class="stringliteral">&#39;,...</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="stringliteral">        &#39;</span>atol<span class="stringliteral">&#39;,int_opts.abstol,&#39;</span>rtol<span class="stringliteral">&#39;,int_opts.rtol,&#39;</span>ism<span class="stringliteral">&#39;,1,&#39;</span>tstart<span class="stringliteral">&#39;,t0);</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="stringliteral">    sol0=fn_handle(tsp0,kinetic_param,int_opts.k,[],options);</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="stringliteral">    catch MExc</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="stringliteral">        disp(MExc);</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="stringliteral">        sol0.t=[];</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="stringliteral">        sol0.y=[];</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="stringliteral">        sol0.sy=[];</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="stringliteral">        sol0.x=[];</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="stringliteral">    end</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="stringliteral">      </span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="stringliteral">    % aggregate results.</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="stringliteral">    time_points=cat(1,sol0.t);</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="stringliteral">    observed_y=cat(1,sol0.y);</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="stringliteral">    unobserved_states=cat(1,sol0.x);</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="stringliteral">    observed_sens_y=sol0.sy;</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="stringliteral">    FIM=[];</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="stringliteral">    measurement_sd=[];</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="stringliteral">    Hessian=[];    residuals=[];</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="stringliteral"></span> </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="stringliteral">end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_projects_2_llamosi2016_2_user_fns_2call_simulation_8m_html_a675cf3332f7c9140d55c01870b188396"><div class="ttname"><a href="../../d7/df5/_projects_2_llamosi2016_2_user_fns_2call_simulation_8m.html#a675cf3332f7c9140d55c01870b188396">callSimulation</a></div><div class="ttdeci">function callSimulation(in varargin)</div></div>
<div class="ttc" id="avar_fun_8m_html_ae8689ef39372b131ddb25d7da78d2b87"><div class="ttname"><a href="../../d8/d7b/var_fun_8m.html#ae8689ef39372b131ddb25d7da78d2b87">varFun</a></div><div class="ttdeci">function varFun(in noise_params, in f_t, in var_type, in varargin)</div><div class="ttdoc">varFun is a function that returns the variance model</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:29 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
